/**
 * $Id$
 *
 * Ethiopian Pan-Amharic layout
 *
 * This software is protected by patent No.2009611147 issued on 20.02.2009 by Russian Federal Service for Intellectual Property Patents and Trademarks.
 *
 * @author Konstantin Wiolowan
 * @copyright 2008-2009 Konstantin Wiolowan <wiolowan@mail.ru>
 * @version $Rev$
 * @lastchange $Author$ $Date$
 */
(function () {
    var vowelsEZ = {e:1,i:2,a:3,ie:4,u:5,o:6,ua:7,Y:8}
       ,EZnonfinal = {
            "'":"'", '`':'`'
           ,'፤':'፤'
           ,'፣':'፣'
           ,'፣፣':'፥'
           ,'፡':'፡'
           ,'_':'_'

           ,'ጭ':'ጭ'     // 'C':'ጭ'
           ,'`ጭ':'ⶽ'    // 'C:ⶽ
           ,'ጭጭ':'ⶽ'  // 'CC':'ⶽ'
           ,'ጭች':'ⶽ'  // 'Cc':'ⶽ'
           ,'ጭo':'ጮ'    // 'Co':'ጮ'
           ,'ጭu':'ጩ'    // 'Cu':'ጩ'

           ,'ዽ':'ዽ'     // 'D':'ዽ'
           ,'ዽo':'ዾ'    // 'Do':'ዾ'
           ,'ዽu':'ዹ'    // 'Du':'ዹ'

           ,'ጝ':'ጝ'     // 'G':'ጝ'
           ,'ጝu':'ጙ'    // 'Gu':'ጙ'

           ,'ሕ':'ሕ'     // 'J':'ሕ'
           ,'ሕu':'ሑ'    // 'Ju':'ሑ'

           ,'ኽ':'ኽ'     // 'K':'ኽ'
           ,'ኽu':'ኹ'    // 'Ku':'ኹ'
           ,'ኽይ':'ⷕ'  // 'Ky':'ⷕ'

           ,'ኝ':'ኝ'     // 'N':'ኝ'
           ,'ኝo':'ኞ'    // 'No':'ኞ'
           ,'ኝu':'ኙ'    // 'Nu':'ኙ'

           ,'ጵ':'ጵ'     // 'P':'ጵ'
           ,'ጵo':'ጶ'    // 'Po':'ጶ'
           ,'ጵu':'ጱ'    // 'Pu':'ጱ'

           ,'ቕ':'ቕ'     // 'Q':'ቕ'
           ,'ቕu':'ቑ'    // 'Qu':'ቑ'

           ,'ጽ':'ጽ'     // 'S':'ጽ'
           ,'ጽu':'ጹ'    // 'Su':'ጹ'
           ,'`ጽ':'ፅ'    // 'S:'ፅ'
           ,'ጽጽ':'ፅ'  // 'SS':'ፅ'
           ,'ጽስ':'ፅ'  // 'Ss':'ፅ'
           ,'ፅo':'ፆ'    // 'SSo':'ፆ'

           ,'ጥ':'ጥ'     // 'T':'ጥ'
           ,'ጥo':'ጦ'    // 'To':'ጦ'
           ,'ጥu':'ጡ'    // 'Tu':'ጡ'

           ,'ዥ':'ዥ'     // 'Z':'ዥ'
           ,'ዥu':'ዡ'    // 'Zu':'ዡ'
           ,'`ዥ':'ⶵ'    // 'Z:'ⶵ'
           ,'ዥዥ':'ⶵ'  // 'ZZ':'ⶵ'
           ,'ዥዝ':'ⶵ'  // 'Zz':'ⶵ'

           ,'ብ':'ብ'     // 'b':'ብ'
           ,'ብo':'ቦ'    // 'bo':'ቦ'
           ,'ብu':'ቡ'    // 'bu':'ቡ'

           ,'ች':'ች'     // 'c':'ች'
           ,'ችu':'ቹ'    // 'cu':'ቹ'
           ,'ችo':'ቾ'    // 'co':'ቾ'
           ,'ችች':'ⶭ'  // 'cc':'ⶭ'

           ,'ድ':'ድ'     // 'd':'ድ'
           ,'ድo':'ዶ'    // 'do':'ዶ'
           ,'ድu':'ዱ'    // 'du':'ዱ'

           ,'ፍ':'ፍ'     // 'f':'ፍ'
           ,'ፍu':'ፉ'    // 'fu':'ፉ'

           ,'ግ':'ግ'     // 'g':'ግ'
           ,'ግo':'ጎ'    // 'go':'ጎ'
           ,'ግu':'ጉ'    // 'gu':'ጉ'
           ,'ግይ':'ⷝ'  // 'gy':'ⷝ'

           ,'ህ':'ህ'     // 'h':'ህ'
           ,'ህo':'ሆ'    // 'ho':'ሆ'
           ,'ህu':'ሁ'    // 'hu':'ሁ'

           ,'`ህ':'ኅ'    // 'h:'ኅ'
           ,'ህህ':'ኅ'  // 'hh':'ኅ'
           ,'ኅo':'ኆ'    // 'hho':'ኆ'
           ,'ኅu':'ኁ'    // 'hhu':'ኁ'

           ,'ጅ':'ጅ'     // 'j':'ጅ'
           ,'ጅo':'ጆ'    // 'jo':'ጆ'
           ,'ጅu':'ጁ'    // 'ju':'ጁ'

           ,'ክ':'ክ'     // 'k':'ክ'
           ,'ክo':'ኮ'    // 'ko':'ኮ'
           ,'ክu':'ኩ'    // 'ku':'ኩ'
           ,'ክይ':'ⷍ'  // 'ky':'ⷍ'

           ,'ል':'ል'     // 'l':'ል'
           ,'ልo':'ሎ'    // 'lo':'ሎ'
           ,'ልu':'ሉ'    // 'lu':'ሉ'

           ,'ም':'ም'     // 'm':'ም'
           ,'ምo':'ሞ'    // 'mo':'ሞ'
           ,'ን':'ን'     // 'n':'ን'
           ,'ንo':'ኖ'    // 'no':'ኖ'
           ,'ንu':'ኑ'    // 'nu':'ኑ'

           ,'ፕ':'ፕ'     // 'p':'ፕ'
           ,'ፕo':'ፖ'    // 'po':'ፖ'
           ,'ፕu':'ፑ'    // 'pu':'ፑ'
           ,'ምu':'ሙ'    // 'mu':'ሙ'

           ,'ቅ':'ቅ'     // 'q':'ቅ'
           ,'ቅo':'ቆ'    // 'qo':'ቆ'
           ,'ቅu':'ቁ'    // 'qu':'ቁ'
           ,'ቅይ':'ⷅ'  // 'qy':'ⷅ'

           ,'ር':'ር'     // 'r':'ር'
           ,'ርo':'ሮ'    // 'ro':'ሮ'
           ,'ርu':'ሩ'    // 'ru':'ሩ'

           ,'ስ':'ስ'     // 's':'ስ'
           ,'ስo':'ሶ'    // 'so':'ሶ'
           ,'ስu':'ሱ'    // 'su':'ሱ'
           ,'`ስ':'ሥ'    // 's:'ሥ'
           ,'ስስ':'ሥ'  // 'ss':'ሥ'
           ,'ሥu':'ሡ'    // 'ssu':'ሡ'

           ,'ት':'ት'     // 't':'ት'
           ,'ትo':'ቶ'    // 'to':'ቶ'
           ,'ትu':'ቱ'    // 'tu':'ቱ'

           ,'ቭ':'ቭ'     // 'v':'ቭ'
           ,'ቭu':'ቩ'    // 'vu':'ቩ'

           ,'ው':'ው'     // 'w':'ው'
           ,'ውo':'ዎ'    // 'wo':'ዎ'

           ,'ሽ':'ሽ'     // 'x':'ሽ'
           ,'ሽo':'ሾ'    // 'xo':'ሾ'
           ,'ሽu':'ሹ'    // 'xu':'ሹ'

           ,'`ሽ':'ⶥ'    // 'x:'ⶥ'
           ,'ሽሽ':'ⶥ'  // 'xx':'ⶥ'

           ,'ይ':'ይ'     // 'y':'ይ'
           ,'ይo':'ዮ'    // 'yo':'ዮ'

           ,'ዝ':'ዝ'     // 'z':'ዝ'
           ,'ዝo':'ዞ'    // 'zo':'ዞ'
           ,'ዝu':'ዙ'    // 'zu':'ዙ'

           ,'a':'አ'       // 'a':'አ'
           ,'አa':'ዓ'    // 'aa':'ዓ'
           ,'u':'ኡ'       // 'u':'ኡ'
           ,'o':'ኦ'       // 'o':'ኦ'
           ,'i':'ኢ'       // 'i':'ኢ'
           ,'ኢi':'ዒ'    // 'ii':'ዒ'
           ,'e':'እ'       // 'e':'እ'

           ,'ጭe':'ጨ'    // 'Ce':'ጨ'
           ,'ⶽe':'ⶸ'    // 'CCe':'ⶸ'
           ,'ዽe':'ዸ'    // 'De':'ዸ'
           ,'ጝe':'ጘ'    // 'Ge':'ጘ'
           ,'ጙe':'ⶓ'    // 'Gue':'ⶓ'
           ,'ሕe':'ሐ'    // 'He':'ሐ'
           ,'ኽe':'ኸ'    // 'Ke':'ኸ'
           ,'ኹe':'ዀ'    // 'Kue':'ዀ'
           ,'ⷕe':'ⷐ'    // 'Kye':'ⷐ'
           ,'ኝe':'ኘ'    // 'Ne':'ኘ'
           ,'ጵe':'ጰ'    // 'Pe':'ጰ'
           ,'ቕe':'ቐ'    // 'Qe':'ቐ'
           ,'ቑe':'ቘ'    // 'Que':'ቘ'
           ,'ጽe':'ጸ'    // 'Se':'ጸ'
           ,'ፅe':'ፀ'    // 'SSe':'ፀ'
           ,'ጥe':'ጠ'    // 'Te':'ጠ'
           ,'ዥe':'ዠ'    // 'Ze':'ዠ'
           ,'ⶵe':'ⶰ'    // 'ZZe':'ⶰ'
           ,'ብe':'በ'    // 'be':'በ'
           ,'ቡe':'ᎄ'    // 'bue':'ᎄ'
           ,'ⶭe':'ⶨ'    // 'cce':'ⶨ'
           ,'ችe':'ቸ'    // 'ce':'ቸ'
           ,'ድe':'ደ'    // 'de':'ደ'
           ,'ፍe':'ፈ'    // 'fe':'ፈ'
           ,'ፉe':'ᎈ'    // 'fue':'ᎈ'
           ,'ግe':'ገ'    // 'ge':'ገ'
           ,'ጉe':'ጐ'    // 'gue':'ጐ'
           ,'ⷝe':'ⷘ'    // 'gye':'ⷘ'
           ,'ህe':'ሀ'    // 'he':'ሀ'
           ,'ኅe':'ኀ'    // 'hhe':'ኀ'
           ,'ኁe':'ኈ'    // 'hhue':'ኈ'
           ,'ጅe':'ጀ'    // 'je':'ጀ'
           ,'ክe':'ከ'    // 'ke':'ከ'
           ,'ኩe':'ኰ'    // 'kue':'ኰ'
           ,'ⷍe':'ⷈ'    // 'kye':'ⷈ'
           ,'ልe':'ለ'    // 'le':'ለ'
           ,'ምe':'መ'    // 'me':'መ'
           ,'ሙe':'ᎀ'    // 'mue':'ᎀ'
           ,'ንe':'ነ'    // 'ne':'ነ'
           ,'ፕe':'ፐ'    // 'pe':'ፐ'
           ,'ፑe':'ᎌ'    // 'pue':'ᎌ'
           ,'ቅe':'ቀ'    // 'qe':'ቀ'
           ,'ⷅe':'ⷀ'    // 'qye':'ⷀ'
           ,'ርe':'ረ'    // 're':'ረ'
           ,'ስe':'ሰ'    // 'se':'ሰ'
           ,'ሥe':'ሠ'    // 'sse':'ሠ'
           ,'ትe':'ተ'    // 'te':'ተ'
           ,'ቭe':'ቨ'    // 've':'ቨ'
           ,'ውe':'ወ'    // 'we':'ወ'
           ,'ሽe':'ሸ'    // 'xe':'ሸ'
           ,'ⶥe':'ⶠ'    // 'xxe':'ⶠ'
           ,'ይe':'የ'    // 'ye':'የ'
           ,'ዝe':'ዘ'    // 'ze':'ዘ'

           ,'ⶽi':'ⶺ'    // 'CCi':'ⶺ'
           ,'ጭi':'ጪ'    // 'Ci':'ጪ'
           ,'ዽi':'ዺ'    // 'Di':'ዺ'
           ,'ጝi':'ጚ'    // 'Gi':'ጚ'
           ,'ሕi':'ሒ'    // 'Ji':'ሒ'
           ,'ኽi':'ኺ'    // 'Ki':'ኺ'
           ,'ኝi':'ኚ'    // 'Ni':'ኚ'
           ,'ጵi':'ጲ'    // 'Pi':'ጲ'
           ,'ቕi':'ቒ'    // 'Qi':'ቒ'
           ,'ጽi':'ጺ'    // 'Si':'ጺ'
           ,'ፅi':'ፂ'    // 'SSi':'ፂ'
           ,'ጥi':'ጢ'    // 'Ti':'ጢ'
           ,'ዥi':'ዢ'    // 'Zi':'ዢ'
           ,'ⶵi':'ⶲ'    // 'ZZi':'ⶲ'
           ,'ብi':'ቢ'    // 'bi':'ቢ'
           ,'ችi':'ቺ'    // 'ci':'ቺ'
           ,'ⶭi':'ⶪ'    // 'cci':'ⶪ'
           ,'ድi':'ዲ'    // 'di':'ዲ'
           ,'ፍi':'ፊ'    // 'fi':'ፊ'
           ,'ግi':'ጊ'    // 'gi':'ጊ'
           ,'ህi':'ሂ'    // 'hi':'ሂ'
           ,'ኅi':'ኂ'    // 'hhi':'ኂ'
           ,'ጅi':'ጂ'    // 'ji':'ጂ'
           ,'ክi':'ኪ'    // 'ki':'ኪ'
           ,'ልi':'ሊ'    // 'li':'ሊ'
           ,'ምi':'ሚ'    // 'mi':'ሚ'
           ,'ንi':'ኒ'    // 'ni':'ኒ'
           ,'ፕi':'ፒ'    // 'pi':'ፒ'
           ,'ቅi':'ቂ'    // 'qi':'ቂ'
           ,'ርi':'ሪ'    // 'ri':'ሪ'
           ,'ስi':'ሲ'    // 'si':'ሲ'
           ,'ሥi':'ሢ'    // 'ssi':'ሢ'
           ,'ትi':'ቲ'    // 'ti':'ቲ'
           ,'ቭi':'ቪ'    // 'vi':'ቪ'
           ,'ውi':'ዊ'    // 'wi':'ዊ'
           ,'ሽi':'ሺ'    // 'xi':'ሺ'
           ,'ⶥi':'ⶢ'    // 'xxi':'ⶢ'
           ,'ይi':'ዪ'    // 'yi':'ዪ'
           ,'ዝi':'ዚ'    // 'zi':'ዚ'

           ,'ጙi':'ⶔ'    // 'Gui':'ⶔ'
           ,'ኹi':'ዂ'    // 'Kui':'ዂ'
           ,'ቑi':'ቚ'    // 'Qui':'ቚ'
           ,'ቡi':'ᎅ'    // 'bui':'ᎅ'
           ,'ፉi':'ᎉ'    // 'fui':'ᎉ'
           ,'ጉi':'ጒ'    // 'gui':'ጒ'
           ,'ሁi':'ኊ'    // 'hui':'ኊ'
           ,'ኁi':'ኊ'    // 'hhui':'ኊ'
           ,'ኩi':'ኲ'    // 'kui':'ኲ'
           ,'ሙi':'ᎁ'    // 'mui':'ᎁ'
           ,'ፑi':'ᎍ'    // 'pui':'ᎍ'
           ,'ቁi':'ቊ'    // 'qui':'ቊ'

           ,'ⷕi':'ⷒ'    // 'Kyi':'ⷒ'
           ,'ⷝi':'ⷚ'    // 'gyi':'ⷚ'
           ,'ⷍi':'ⷊ'    // 'kyi':'ⷊ'
           ,'ⷅi':'ⷂ'    // 'qyi':'ⷂ'


           ,"'1":'፩'      // "'1":'፩'
           ,"'2":'፪'      // "'2":'፪'
           ,"'3":'፫'      // "'3":'፫'
           ,"'4":'፬'      // "'4":'፬'
           ,"'5":'፭'      // "'5":'፭'
           ,"'6":'፮'      // "'6":'፮'
           ,"'7":'፯'      // "'7":'፯'
           ,"'8":'፰'      // "'8":'፰'
           ,"'9":'፱'      // "'9":'፱'
           ,'`1':'፩'      // '`1':'፩'
           ,'`2':'፪'      // '`2':'፪'
           ,'`3':'፫'      // '`3':'፫'
           ,'`4':'፬'      // '`4':'፬'
           ,'`5':'፭'      // '`5':'፭'
           ,'`6':'፮'      // '`6':'፮'
           ,'`7':'፯'      // '`7':'፯'
           ,'`8':'፰'      // '`8':'፰'
           ,'`9':'፱'      // '`9':'፱'


           ,"፩0":'፲'    // "፩0":'፲'
           ,'፲0':'፻'    // '፲0':'፻'
           ,'፻0':'፲፻'
        }
       ,EZfinal = {
            'ጪe':'ጬ'    // 'Cie':'ጬ'
           ,'ⶺe':'ⶼ'    // 'CCie':'ⶼ'
           ,'ዺe':'ዼ'    // 'Die':'ዼ'
           ,'ጚe':'ጜ'    // 'Gie':'ጜ'
           ,'ⶔe':'ⶕ'    // 'Guie':'ⶕ'
           ,'ሒe':'ሔ'    // 'Hie':'ሔ'
           ,'ኺe':'ኼ'    // 'Kie':'ኼ'
           ,'ዂe':'ዄ'    // 'Kuie':'ዄ'
           ,'ⷒe':'ⷔ'    // 'Kyie':'ⷔ'
           ,'ኚe':'ኜ'    // 'Nie':'ኜ'
           ,'ጲe':'ጴ'    // 'Pie':'ጴ'
           ,'ቒe':'ቔ'    // 'Qie':'ቔ'
           ,'ቚe':'ቜ'    // 'Quie':'ቜ'
           ,'ጺe':'ጼ'    // 'Sie':'ጼ'
           ,'ፂe':'ፄ'    // 'SSie':'ፄ'
           ,'ጢe':'ጤ'    // 'Tie':'ጤ'
           ,'ዢe':'ዤ'    // 'Zie':'ዤ'
           ,'ⶲe':'ⶴ'    // 'ZZie':'ⶴ'
           ,'ቢe':'ቤ'    // 'bie':'ቤ'
           ,'ᎅe':'ᎆ'    // 'buie':'ᎆ'
           ,'ⶪe':'ⶬ'    // 'ccie':'ⶬ'
           ,'ቺe':'ቼ'    // 'cie':'ቼ'
           ,'ዲe':'ዴ'    // 'die':'ዴ'
           ,'ፊe':'ፌ'    // 'fie':'ፌ'
           ,'ᎉe':'ᎊ'    // 'fuie':'ᎊ'
           ,'ጊe':'ጌ'    // 'gie':'ጌ'
           ,'ጒe':'ጔ'    // 'guie':'ጔ'
           ,'ⷚe':'ⷜ'    // 'gyie':'ⷜ'
           ,'ሂe':'ሄ'    // 'hie':'ሄ'
           ,'ኂe':'ኄ'    // 'hhie':'ኄ'
           ,'ኊe':'ኌ'    // 'hhuie':'ኌ'
           ,'ጂe':'ጄ'    // 'jie':'ጄ'
           ,'ኪe':'ኬ'    // 'kie':'ኬ'
           ,'ኲe':'ኴ'    // 'kuie':'ኴ'
           ,'ⷊe':'ⷌ'    // 'kyie':'ⷌ'
           ,'ሊe':'ሌ'    // 'lie':'ሌ'
           ,'ሚe':'ሜ'    // 'mie':'ሜ'
           ,'ᎁe':'ᎂ'    // 'muie':'ᎂ'
           ,'ኒe':'ኔ'    // 'nie':'ኔ'
           ,'ፒe':'ፔ'    // 'pie':'ፔ'
           ,'ᎍe':'ᎎ'    // 'puie':'ᎎ'
           ,'ቁe':'ቈ'    // 'que':'ቈ'
           ,'ቂe':'ቄ'    // 'qie':'ቄ'
           ,'ቊe':'ቌ'    // 'quie':'ቌ'
           ,'ⷂe':'ⷄ'    // 'qyie':'ⷄ'
           ,'ሪe':'ሬ'    // 'rie':'ሬ'
           ,'ሲe':'ሴ'    // 'sie':'ሴ'
           ,'ሢe':'ሤ'    // 'ssie':'ሤ'
           ,'ቲe':'ቴ'    // 'tie':'ቴ'
           ,'ቪe':'ቬ'    // 'vie':'ቬ'
           ,'ዊe':'ዌ'    // 'wie':'ዌ'
           ,'ሺe':'ሼ'    // 'xie':'ሼ'
           ,'ⶢe':'ⶤ'    // 'xxie':'ⶤ'
           ,'ዪe':'ዬ'    // 'yie':'ዬ'
           ,'ዚe':'ዜ'    // 'zie':'ዜ'

           ,'ጭE':'ጬ'    // 'Ce':'ጨ'
           ,'ⶽE':'ⶼ'    // 'CCE':'ⶼ'
           ,'ዽE':'ዼ'    // 'DE':'ዼ'
           ,'ጝE':'ጜ'    // 'GE':'ጜ'
           ,'ጙE':'ⶕ'    // 'GuE':'ⶕ'
           ,'ሕE':'ሔ'    // 'HE':'ሔ'
           ,'ኽE':'ኼ'    // 'KE':'ኼ'
           ,'ኹE':'ዄ'    // 'KuE':'ዄ'
           ,'ⷕE':'ⷔ'    // 'KyE':'ⷔ'
           ,'ኝE':'ኜ'    // 'NE':'ኜ'
           ,'ጵE':'ጴ'    // 'PE':'ጴ'
           ,'ቕE':'ቔ'    // 'QE':'ቔ'
           ,'ቑE':'ቜ'    // 'QuE':'ቜ'
           ,'ጽE':'ጼ'    // 'SE':'ጼ'
           ,'ፅE':'ፄ'    // 'SSE':'ፄ'
           ,'ጥE':'ጤ'    // 'TE':'ጤ'
           ,'ዥE':'ዤ'    // 'ZE':'ዤ'
           ,'ⶵE':'ⶴ'    // 'ZZE':'ⶴ'
           ,'ብE':'ቤ'    // 'bE':'ቤ'
           ,'ቡE':'ᎆ'    // 'buE':'ᎆ'
           ,'ⶭE':'ⶬ'    // 'ccE':'ⶬ'
           ,'ችE':'ቼ'    // 'cE':'ቼ'
           ,'ድE':'ዴ'    // 'dE':'ዴ'
           ,'ፍE':'ፌ'    // 'fE':'ፌ'
           ,'ፉE':'ᎊ'    // 'fuE':'ᎊ'
           ,'ግE':'ጌ'    // 'gE':'ጌ'
           ,'ጉE':'ጔ'    // 'guE':'ጔ'
           ,'ⷝE':'ⷜ'    // 'gyE':'ⷜ'
           ,'ህE':'ሄ'    // 'hE':'ሄ'
           ,'ኅE':'ኄ'    // 'hhE':'ኄ'
           ,'ኁE':'ኌ'    // 'hhuE':'ኌ'
           ,'ጅE':'ጄ'    // 'jE':'ጄ'
           ,'ክE':'ኬ'    // 'kE':'ኬ'
           ,'ኩE':'ኴ'    // 'kuE':'ኴ'
           ,'ⷍE':'ⷌ'    // 'kyE':'ⷌ'
           ,'ልE':'ሌ'    // 'lE':'ሌ'
           ,'ምE':'ሜ'    // 'mE':'ሜ'
           ,'ሙE':'ᎂ'    // 'muE':'ᎂ'
           ,'ንE':'ኔ'    // 'nE':'ኔ'
           ,'ፕE':'ፔ'    // 'pE':'ፔ'
           ,'ፑE':'ᎌ'    // 'puE':'ᎌ'
           ,'ቅE':'ቄ'    // 'qE':'ቄ'
           ,'ⷅE':'ⷄ'    // 'qyE':'ⷄ'
           ,'ርE':'ሬ'    // 'rE':'ሬ'
           ,'ስE':'ሴ'    // 'sE':'ሴ'
           ,'ሥE':'ሤ'    // 'ssE':'ሤ'
           ,'ትE':'ቴ'    // 'tE':'ቴ'
           ,'ቭE':'ቬ'    // 'vE':'ቬ'
           ,'ውE':'ዌ'    // 'wE':'ዌ'
           ,'ሽE':'ሼ'    // 'xE':'ሼ'
           ,'ⶥE':'ⶤ'    // 'xxE':'ⶤ'
           ,'ይE':'ዬ'    // 'yE':'ዬ'
           ,'ዝE':'ዜ'    // 'zE':'ዜ'

           ,'ጨe':'ጬ'    // 'Cee':'ጬ'
           ,'ⶸe':'ⶼ'    // 'CCee':'ⶼ'
           ,'ዸe':'ዼ'    // 'Dee':'ዼ'
           ,'ጘe':'ጜ'    // 'Gee':'ጜ'
           ,'ⶓe':'ⶕ'    // 'Guee':'ⶕ'
           ,'ሐe':'ሔ'    // 'Hee':'ሔ'
           ,'ኸe':'ኼ'    // 'Kee':'ኼ'
           ,'ዀe':'ዄ'    // 'Kuee':'ዄ'
           ,'ⷐe':'ⷔ'    // 'Kyee':'ⷔ'
           ,'ኘe':'ኜ'    // 'Nee':'ኜ'
           ,'ጰe':'ጴ'    // 'Pee':'ጴ'
           ,'ቐe':'ቔ'    // 'Qee':'ቔ'
           ,'ቘe':'ቜ'    // 'Quee':'ቜ'
           ,'ጸe':'ጼ'    // 'See':'ጼ'
           ,'ፀe':'ፄ'    // 'SSee':'ፄ'
           ,'ጠe':'ጤ'    // 'Tee':'ጤ'
           ,'ዠe':'ዤ'    // 'Zee':'ዤ'
           ,'ⶰe':'ⶴ'    // 'ZZee':'ⶴ'
           ,'በe':'ቤ'    // 'bee':'ቤ'
           ,'ᎄe':'ᎆ'    // 'buee':'ᎆ'
           ,'ⶨe':'ⶬ'    // 'ccee':'ⶬ'
           ,'ቸe':'ቼ'    // 'cee':'ቼ'
           ,'ደe':'ዴ'    // 'dee':'ዴ'
           ,'ፈe':'ፌ'    // 'fee':'ፌ'
           ,'ᎈe':'ᎊ'    // 'fuee':'ᎊ'
           ,'ገe':'ጌ'    // 'gee':'ጌ'
           ,'ጐe':'ጔ'    // 'guee':'ጔ'
           ,'ⷘe':'ⷜ'    // 'gyee':'ⷜ'
           ,'ሀe':'ሄ'    // 'hee':'ሄ'
           ,'ኀe':'ኄ'    // 'hhee':'ኄ'
           ,'ኈe':'ኌ'    // 'hhuee':'ኌ'
           ,'ጀe':'ጄ'    // 'jee':'ጄ'
           ,'ከe':'ኬ'    // 'kee':'ኬ'
           ,'ኰe':'ኴ'    // 'kuee':'ኴ'
           ,'ⷈe':'ⷌ'    // 'kyee':'ⷌ'
           ,'ለe':'ሌ'    // 'lee':'ሌ'
           ,'መe':'ሜ'    // 'mee':'ሜ'
           ,'ᎀe':'ᎂ'    // 'muee':'ᎂ'
           ,'ነe':'ኔ'    // 'nee':'ኔ'
           ,'ፐe':'ፔ'    // 'pee':'ፔ'
           ,'ᎌe':'ᎌ'    // 'puee':'ᎌ'
           ,'ቀe':'ቄ'    // 'qee':'ቄ'
           ,'ⷀe':'ⷄ'    // 'qyee':'ⷄ'
           ,'ረe':'ሬ'    // 'ree':'ሬ'
           ,'ሰe':'ሴ'    // 'see':'ሴ'
           ,'ሠe':'ሤ'    // 'ssee':'ሤ'
           ,'ተe':'ቴ'    // 'tee':'ቴ'
           ,'ቨe':'ቬ'    // 'vee':'ቬ'
           ,'ወe':'ዌ'    // 'wee':'ዌ'
           ,'ሸe':'ሼ'    // 'xee':'ሼ'
           ,'ⶠe':'ⶤ'    // 'xxee':'ⶤ'
           ,'የe':'ዬ'    // 'yee':'ዬ'
           ,'ዘe':'ዜ'    // 'zee':'ዜ'



           ,'ጭa':'ጫ'    // 'Ca':'ጫ'
           ,'ጮa':'ⶐ'    // 'Coa':'ⶐ'
           ,'ጩa':'ጯ'    // 'Cua':'ጯ'
           ,'ⶽa':'ⶻ'    // 'CCa':'ⶻ'
           ,'ⶽo':'ⶾ'    // 'CCo':'ⶾ'
           ,'ⶽu':'ⶹ'    // 'CCu':'ⶹ'

           ,'ዽa':'ዻ'    // 'Da':'ዻ'
           ,'ዾa':'ⶍ'    // 'Doa':'ⶍ'
           ,'ዹa':'ዿ'    // 'Dua':'ዿ'

           ,'ጝa':'ጛ'    // 'Ga':'ጛ'
           ,'ጝo':'ጞ'    // 'Go':'ጞ'
           ,'ጙa':'ጟ'    // 'Gua':'ጟ'
           ,'ጙu':'ⶖ'    // 'Guu':'ⶖ'

           ,'ሕa':'ሓ'    // 'Ha':'ሓ'
           ,'ሕo':'ሖ'    // 'Ho':'ሖ'
           ,'ሑa':'ሗ'    // 'Hua':'ሗ'

           ,'ኽa':'ኻ'    // 'Ka':'ኻ'
           ,'ኽo':'ኾ'    // 'Ko':'ኾ'

           ,'ⷕa':'ⷓ'    // 'Kya':'ⷓ'
           ,'ኹu':'ዅ'    // 'Kuu':'ዅ'
           ,'ኹa':'ዃ'    // 'Kua':'ዃ'
           ,'ⷕo':'ⷖ'    // 'Kyo':'ⷖ'
           ,'ⷕu':'ⷑ'    // 'Kyu':'ⷑ'

           ,'ኝa':'ኛ'    // 'Na':'ኛ'
           ,'ኞa':'ⶉ'    // 'Noa':'ⶉ'
           ,'ኙa':'ኟ'    // 'Nua':'ኟ'

           ,'ጵa':'ጳ'    // 'Pa':'ጳ'
           ,'ጶa':'ⶑ'    // 'Poa':'ⶑ'
           ,'ጱa':'ጷ'    // 'Pua':'ጷ'

           ,'ቕa':'ቓ'    // 'Qa':'ቓ'
           ,'ቕo':'ቖ'    // 'Qo':'ቖ'
           ,'ቑa':'ቛ'    // 'Qua':'ቛ'
           ,'ቑu':'ቝ'    // 'Quu':'ቝ'

           ,'ጽa':'ጻ'    // 'Sa':'ጻ'
           ,'ጽo':'ጾ'    // 'So':'ጾ'
           ,'ጹa':'ጿ'    // 'Sua':'ጿ'

           ,'ፅa':'ፃ'    // 'SSa':'ፃ'
           ,'ፆa':'ፇ'    // 'SSoa':'ፇ'
           ,'ፅu':'ፁ'    // 'SSu':'ፁ'

           ,'ጥa':'ጣ'    // 'Ta':'ጣ'
           ,'ጦa':'ⶏ'    // 'Toa':'ⶏ'
           ,'ጡa':'ጧ'    // 'Tua':'ጧ'

           ,'ዥa':'ዣ'    // 'Za':'ዣ'
           ,'ዥo':'ዦ'    // 'Zo':'ዦ'
           ,'ዡa':'ዧ'    // 'Zua':'ዧ'

           ,'ⶵa':'ⶳ'    // 'ZZa':'ⶳ'
           ,'ⶵo':'ⶶ'    // 'ZZo':'ⶶ'
           ,'ⶵu':'ⶱ'    // 'ZZu':'ⶱ'

           ,'ብa':'ባ'    // 'ba':'ባ'
           ,'ቦa':'ⶅ'    // 'boa':'ⶅ'
           ,'ቡa':'ቧ'    // 'bua':'ቧ'
           ,'ቡu':'ᎇ'    // 'buu':'ᎇ'

           ,'ⶭa':'ⶫ'    // 'cca':'ⶫ'
           ,'ⶭo':'ⶮ'    // 'cco':'ⶮ'
           ,'ⶭu':'ⶩ'    // 'ccu':'ⶩ'

           ,'ችa':'ቻ'    // 'ca':'ቻ'
           ,'ቹa':'ቿ'    // 'cua':'ቿ'
           ,'ቾa':'ⶇ'    // 'coa':'ⶇ'

           ,'ድa':'ዳ'    // 'da':'ዳ'
           ,'ዶa':'ⶌ'    // 'doa':'ⶌ'
           ,'ዱa':'ዷ'    // 'dua':'ዷ'

           ,'ፍa':'ፋ'    // 'fa':'ፋ'
           ,'ፍo':'ፎ'    // 'fo':'ፎ'
           ,'ፉa':'ፏ'    // 'fua':'ፏ'
           ,'ፉu':'ᎋ'    // 'fuu':'ᎋ'

           ,'ግa':'ጋ'    // 'ga':'ጋ'
           ,'ጎa':'ጏ'    // 'goa':'ጏ'
           ,'ጉa':'ጓ'    // 'gua':'ጓ'
           ,'ጉu':'ጕ'    // 'guu':'ጕ'

           ,'ⷝa':'ⷛ'    // 'gya':'ⷛ'
           ,'ⷝo':'ⷞ'    // 'gyo':'ⷞ'
           ,'ⷝu':'ⷙ'    // 'gyu':'ⷙ'

           ,'ህa':'ሃ'    // 'ha':'ሃ'
           ,'ሆa':'ሇ'    // 'hoa':'ሇ'
           ,'ሁa':'ኋ'    // 'hua':'ኋ'
           ,'ሁe':'ኈ'    // 'hue':'ኈ'
           ,'ሁu':'ኍ'    // 'huu':'ኍ'

           ,'ኅa':'ኃ'    // 'hha':'ኃ'
           ,'ኆa':'ኇ'    // 'hhoa':'ኇ'
           ,'ኁa':'ኋ'    // 'hhua':'ኋ'
           ,'ኁu':'ኍ'    // 'hhuu':'ኍ'

           ,'ጅa':'ጃ'    // 'ja':'ጃ'
           ,'ጆa':'ⶎ'    // 'joa':'ⶎ'
           ,'ጁa':'ጇ'    // 'jua':'ጇ'

           ,'ክa':'ካ'    // 'ka':'ካ'
           ,'ኮa':'ኯ'    // 'koa':'ኯ'
           ,'ኩa':'ኳ'    // 'kua':'ኳ'
           ,'ኩu':'ኵ'    // 'kuu':'ኵ'

           ,'ⷍa':'ⷋ'    // 'kya':'ⷋ'
           ,'ⷍo':'ⷎ'    // 'kyo':'ⷎ'
           ,'ⷍu':'ⷉ'    // 'kyu':'ⷉ'

           ,'ልa':'ላ'    // 'la':'ላ'
           ,'ሎa':'ⶀ'    // 'loa':'ⶀ'
           ,'ሉa':'ሏ'    // 'lua':'ሏ'

           ,'ምa':'ማ'    // 'ma':'ማ'
           ,'ሞa':'ⶁ'    // 'moa':'ⶁ'
           ,'ሙa':'ሟ'    // 'mua':'ሟ'
           ,'ሙu':'ᎃ'    // 'muu':'ᎃ'

           ,'ንa':'ና'    // 'na':'ና'
           ,'ኖa':'ⶈ'    // 'noa':'ⶈ'
           ,'ኑa':'ኗ'    // 'nua':'ኗ'

           ,'ፕa':'ፓ'    // 'pa':'ፓ'
           ,'ፖa':'ⶒ'    // 'poa':'ⶒ'
           ,'ፑa':'ፗ'    // 'pua':'ፗ'
           ,'ፑu':'ᎏ'    // 'puu':'ᎏ'

           ,'ቅa':'ቃ'    // 'qa':'ቃ'
           ,'ቆa':'ቇ'    // 'qoa':'ቇ'
           ,'ቁa':'ቋ'    // 'qua':'ቋ'
           ,'ቁu':'ቍ'    // 'quu':'ቍ'

           ,'ⷅa':'ⷃ'    // 'qya':'ⷃ'
           ,'ⷅo':'ⷆ'    // 'qyo':'ⷆ'
           ,'ⷅu':'ⷁ'    // 'qyu':'ⷁ'

           ,'ርa':'ራ'    // 'ra':'ራ'
           ,'ሮa':'ⶂ'    // 'roa':'ⶂ'
           ,'ሩa':'ሯ'    // 'rua':'ሯ'

           ,'ስa':'ሳ'    // 'sa':'ሳ'
           ,'ሶa':'ⶃ'    // 'soa':'ⶃ'
           ,'ሱa':'ሷ'    // 'sua':'ሷ'

           ,'ሥa':'ሣ'    // 'ssa':'ሣ'
           ,'ሥo':'ሦ'    // 'sso':'ሦ'
           ,'ሡa':'ሧ'    // 'ssua':'ሧ'

           ,'ትa':'ታ'    // 'ta':'ታ'
           ,'ቶa':'ⶆ'    // 'toa':'ⶆ'
           ,'ቱa':'ቷ'    // 'tua':'ቷ'

           ,'ቭa':'ቫ'    // 'va':'ቫ'
           ,'ቭo':'ቮ'    // 'vo':'ቮ'
           ,'ቩa':'ቯ'    // 'vua':'ቯ'

           ,'ውa':'ዋ'    // 'wa':'ዋ'
           ,'ዎa':'ዏ'    // 'woa':'ዏ'
           ,'ውu':'ዉ'    // 'wu':'ዉ'

           ,'ሽa':'ሻ'    // 'xa':'ሻ'
           ,'ሾa':'ⶄ'    // 'xoa':'ⶄ'
           ,'ሹa':'ሿ'    // 'xua':'ሿ'


           ,'ⶥa':'ⶣ'    // 'xxa':'ⶣ'
           ,'ⶥo':'ⶦ'    // 'xxo':'ⶦ'
           ,'ⶥu':'ⶡ'    // 'xxu':'ⶡ'

           ,'ይa':'ያ'    // 'ya':'ያ'
           ,'ዮa':'ዯ'    // 'yoa':'ዯ'
           ,'ይu':'ዩ'    // 'yu':'ዩ'

           ,'ዝa':'ዛ'    // 'za':'ዛ'
           ,'ዞa':'ⶋ'    // 'zoa':'ⶋ'
           ,'ዙa':'ዟ'    // 'zua':'ዟ'

           ,'እa':'ኣ'    // 'ea':'ኣ'
           ,'ኢe':'ኤ'    // 'ie':'ኤ'
           ,'አe':'ኧ'    // 'ae':'ኧ'
           ,'ዓa':'ዐ'    // 'aaa':'ዐ'
           ,'`e':'ዐ'      //
           ,'ኡu':'ዑ'    // 'uu':'ዑ'
           ,'`u':'ዑ'      //
           ,'`i':'ዒ'      //
           ,'`a':'ዓ'      //
           ,'ዒe':'ዔ'    // 'iie':'ዔ'
           ,'`E':'ዔ'      //
           ,'እe':'ዕ'    // 'ee':'ዕ'
           ,'`ዕ':'ዕ'    //
           ,'ኦo':'ዖ'    // 'oo':'ዖ'
           ,'`o':'ዖ'      //
           ,'ኦa':'ⶊ'    // 'oa':'ⶊ'


           ,'፲፻0':'፼' // '፲፻0':'፼'
           ,"''":"'"        // "''":"'"
           ,'፤፤':';'    // '፤፤':';'
           ,'፥፣':','    // '፥፣':'

           ,'፡፡':'።'  // '፡፡':'።'
           ,'፡-':'፦'    // '፡-':'፦'
           ,'፡+':'፠'    // '፡+':'፠'
           ,'፡#':'፨'    // '፡#':'፨'

           ,'_1':'᎐'      // '_1':'᎐'
           ,'_2':'᎑'      // '_2':'᎑'
           ,'_3':'᎒'      // '_3':'᎒'
           ,'_4':'᎓'      // '_4':'᎓'
           ,'_5':'᎔'      // '_5':'᎔'
           ,'_6':'᎕'      // '_6':'᎕'
           ,'_7':'᎖'      // '_7':'᎖'
           ,'_8':'᎘'      // '_8':'᎘'
           ,'_0':'᎙'      // '_0':'᎙'
           ,'__':'_'        // '__':'_'

           ,'፪0':'፳'    // '፪0':'፳'
           ,'፫0':'፴'    // '፫0':'፴'
           ,'፬0':'፵'    // '፬0':'፵'
           ,'፭0':'፶'    // '፭0':'፶'
           ,'፮0':'፷'    // '፮0':'፷'
           ,'፯0':'፸'    // '፯0':'፸'
           ,'፰0':'፹'    // '፰0':'፹'
           ,'፱0':'፺'
        };

    return function (chr, buf) {
        var str = buf+chr
           ,len = 1;
        if (chr=='\u0008') { // backspace
            if (buf.length) {
                for (var key in EZnonfinal) {
                    if (EZnonfinal[key] == buf) {
                        return (key==buf || /^[A-z]/.test(key) ? ['',0]
                                                               : [key.charAt(0),1]);
                    }
                }
                str = '';
                len = 0;
            }
        } else if (buf && chr=="'" && buf!="'") {
            if (/[፻፩፪፫፬፭፮፯፰፱፼፲፳፴፵፶፷፸፹፺]/.test(buf)) {
                str = buf+chr;
            } else {
                str = buf;
                len = 0;
            }
        } else {
            chr = VirtualKeyboard.Langs.ET.conv[chr]||chr;
            if (str = EZnonfinal[buf+chr]) {
                len = str.length;
            } else if (str = EZfinal[buf+chr]) {
                len = 0;
            } else if (str = EZnonfinal[chr]) {
                str = buf + str;
            } else {
                str = buf + chr;
                len = 0;
            }
       }
       return [str, len];
    }
})()
